#include "hdtree.h"
#include <string>
#include <sstream>
#include "mtimer.h"
#include <algorithm>
#include <fstream>


using namespace std;


int main(int argc, char * argv[])
{
  if(argc!=3)
    {
      cerr<<"Usage:./sample <datafile> <dataformat:0 for raw data, 1 for segment data>"<<endl;
      exit(1);
    }
  
  vector <double> sec;
  double x=0, y=0;
  int format=atoi(argv[2]);
  /**************/

  SDB sdb(argv[1]);
  if (format==0)
    sdb.readData();
  else
    sdb.readEasyData();

  /**************/
  //cerr<<sdb.segs.size()<<endl<<flush;
  segment tmpseg;
  long c=0;
  for(uint i=0;i<sdb.segs.size();i++)
    {
      sec.clear();
      for(uint j=0;j<sdb.segs.size();j++)
	{
	  if(sdb.segs[i].objid==sdb.segs[j].objid)
	    continue;
	  if(sdb.segs[i].end.x<sdb.segs[j].start.x)
	    break;
	  if(!(sdb.segs[i].start.x>sdb.segs[j].end.x)&&
	     (Tools::lineSegmentIntersection(sdb.segs[i].start.x, sdb.segs[i].start.y,
				      sdb.segs[i].end.x, sdb.segs[i].end.y,
				      sdb.segs[j].start.x, sdb.segs[j].start.y,
				      sdb.segs[j].end.x, sdb.segs[j].end.y,
				      &x,&y)))
	    {
	      sec.push_back(x);
	    }
	}

      sort(sec.begin(),sec.end());
      tmpseg=sdb.segs[i];
      for(uint k=0;k<sec.size();k++)
	{
	  tmpseg.end.x=sec[k];
	  cout<<(long)(tmpseg.start.x*100)<<"\t"
	      <<(long)(tmpseg.start.y*100)<<"\t"
	      <<(long)(tmpseg.end.x*100)<<"\t"
	      <<(long)(tmpseg.end.y*100)<<"\t"
	      <<tmpseg.objid<<"\t"<<"i\n";
	  tmpseg.start=tmpseg.end;
	  c++;
	}
      tmpseg.end=sdb.segs[i].end;
      cout<<(long)(tmpseg.start.x*100)<<"\t"
	  <<(long)(tmpseg.start.y*100)<<"\t"
	  <<(long)(tmpseg.end.x*100)<<"\t"
	  <<(long)(tmpseg.end.y*100)<<"\t"
	  <<tmpseg.objid<<"\t"<<"i\n";
      c++;
    }  
  /******************/
  cout<<c<<endl;

  return 0;
}
