#include "rhdtree.h"
#include <string>
#include <sstream>
#include "mtimer.h"

using namespace std;


int main(int argc, char * argv[])
{
  if(argc!=4)
    {
      cerr<<"Usage:./buildRSEB.exe <datafile> <Bsize> kmax"<<endl;
      exit(1);
    }
  /**************/
  MTimer overall;
  overall.go();

  SDB sdb(argv[1]);
  sdb.readData();
  int j=0,stop;
  int lstsize;
  int Bsize=atoi(argv[2])*1024/40;  
  int kmax=atoi(argv[3]);

  //  cerr<<"read"<<endl;
  lstsize=sdb.N;
  double NB=0.0;
  NB=(double)lstsize/(double)Bsize;
  double srate=1.0/(double)Bsize;	
  if (kmax<Bsize)
	  stop=(int)ceil(sqrt(log(NB)/log(2.0)));
  else
 	  stop=(int)ceil(sqrt(log(NB)/log(2.0))+log((double)kmax/(double)Bsize)/log(2.0));
  double ussize=0,insertc=0, qnode=0;
  vector <uint> unsmplst;
  vector<segment> smplst;
  vector<RHDTree*> trees;
  MTimer bldHDT;
  MTimer queryHDT;
  MTimer writeCFL;

  for (j=0;j<=stop;j++)
  {
	 sdb.sample(srate,smplst, unsmplst);
	 RHDTree* tree=new RHDTree(smplst, &(sdb.rng), j);
	 bldHDT.go();
	 tree->buildtree(argv[1]);
	 bldHDT.stop();
 	 bldHDT.update();
	 trees.push_back(tree);
	 unsmplst.clear();
         smplst.clear();
         srate=srate/2.0;
  }
 queryHDT.go();
  for (j=stop;j>=0;j--)
	trees[j]->buildContainList(trees);
  for (j=0;j<=stop;j++)
  {	
  	for (uint i=0;i<sdb.N;i++)
		trees[j]->insert2confl(sdb.segs[i], i);
	insertc+=trees[j]->count;
	qnode+=trees[j]->qnode;
  }
  queryHDT.stop();
  queryHDT.update();
  writeCFL.go();
  for (j=0;j<=stop;j++)
	trees[j]->writeConflictEnvelop(sdb.segs, argv[1]);
   writeCFL.stop();
   writeCFL.update();

    /*trick thresh,total, total-readdata, build env, build HDT, query HDT, time computing intersection, total branch, outputCFL, touched CFL, total unsampled, touch CFL/total unsample, 
    total qtreetime/total unsample*/
  overall.stop();
  overall.update();
  ussize=sdb.N*(stop+1);
  cout<<sdb.N<<" "<<overall.elapsed<<" "<<bldHDT.elapsed<<" "/*<<skytm<<" "*/<<queryHDT.elapsed<<" "<<writeCFL.elapsed<<" "<<insertc<<" "<<qnode<<" "<<ussize<<" "<<insertc/(double)ussize<<" "<<qnode/(double)ussize<<" "<<queryHDT.elapsed/(double)ussize<<" "<<flush;
  ofstream indexfile;
  char filename[100]="";
  strcpy(filename, argv[1]);
  strcat(filename, "Index/config");
  indexfile.open(filename);
  indexfile<<j<<" "<<sdb.N<<endl;
  indexfile.close();
  char trans[100]="";
  sprintf(trans,"./buildNBtree.exe %d %d %s",stop+1,atoi(argv[2]),argv[1]);					 
        system(trans);								 
  return 0;
}
