#include "cgalenvelop.h"

Envelope::Envelope()
{}

Envelope::~Envelope()
{}

void Envelope::getenvlp(vector<segment>& input, list<segment>& output)
{
  	std::list<Labeled_segment_2>   insegs;
	Number_type q1(0.5),q2(0.5),q3(0.5),q4(0.5);
	point p1, p2;
	p1.x=0.0;
	p1.y=1.0;
	p2.x=Tools::xMAX;
	p2.y=1.0;
	segment bottom;
	bottom.buildseg(p1, p2, Tools::MAX, 1);
	//input.push_back(bottom);
	uint insize=input.size();
	uint i;
	for (i=0;i<insize;i++)
 	{ 
	  q1= input[i].start.x;
	  q2= input[i].start.y;
	  q3= input[i].end.x;
	  q4= input[i].end.y;
	  insegs.push_back (Labeled_segment_2 (Segment_2 (Point_2 (q1,q2),
                                                    Point_2 (q3,q4)), i));
	}
	Diagram_1              min_diag;
  	upper_envelope_x_monotone_2 (insegs.begin(), insegs.end(),  min_diag);
  	Diagram_1::Edge_const_handle     ce = min_diag.leftmost();
	Diagram_1::Vertex_const_handle   cev;
	Diagram_1::Curve_const_iterator  cit;
	uint cedge=0;
	double px=0.0, py=0.0, cx=0.0, cy=0.0;
	//bool first=true;
	bool cempty=true;
	px=0.0;
	py=1.0;
  	while (ce != min_diag.rightmost())
	{
	    //std::cout << "Edge:";
	    if (! ce->is_empty())
	    {
	      	//for (cit = e->curves_begin(); cit != e->curves_end(); ++cit)
		cit=ce->curves_begin();
        	cedge= cit->data();
		cempty=false;
//		cout<<"Edge: "<<cedge<<endl;
    	    }
	    else
	    {
	 //       std::cout << " [empty]"<<endl;
		cempty=true;
	    }

	    cev = ce->right();
	    cx=CGAL::to_double(cev->point().x()); 
	    cy=CGAL::to_double(cev->point().y()); 

	//	cout<<cx<<" "<<cy<<endl;
	    if (!Tools::double_eq(px,cx,6))
	    {
			if (!cempty)
				cy=input[cedge].calculateY(cx);
			else
				//py=bottom.calculateY(px);
				cy=1.0;
			if (!cempty)
				py=input[cedge].calculateY(px);
			else
				py=1.0;
			
			segment sline;
			p1.x=px;
			p1.y=py;
			p2.x=cx;
			p2.y=cy;
			if (!cempty)
				sline.buildseg(p1, p2, input[cedge].objid,input[cedge].segid);
			else
				sline.buildseg(p1, p2, Tools::MAX, 0);
			output.push_back(sline);
	    }

		px=cx;
		py=cy;

	    ce = cev->right();
	}	
	  CGAL_assertion (ce->is_empty());
	if (Tools::double_le(Tools::xMAX, cx, 6))
	{
		segment sline;
		p1.x=px;
		p1.y=1;
		p2.x=Tools::xMAX;
		p2.y=1;
		sline.buildseg(p1, p2, Tools::MAX, 0);
		output.push_back(sline);
	}
	  //std::cout << "Edge: [empty]" << std::endl;
}

void Envelope::getenvlp(vector<segment>& input, vector<segment>& output)
{
  	std::list<Labeled_segment_2>   insegs;
	Number_type q1(0.5),q2(0.5),q3(0.5),q4(0.5);
	point p1, p2;
	p1.x=0.0;
	p1.y=1.0;
	p2.x=Tools::xMAX;
	p2.y=1.0;
	segment bottom;
	bottom.buildseg(p1, p2, Tools::MAX, 1);
	//input.push_back(bottom);
	uint insize=input.size();
	uint i;
	for (i=0;i<insize;i++)
 	{ 
	  q1= input[i].start.x;
	  q2= input[i].start.y;
	  q3= input[i].end.x;
	  q4= input[i].end.y;
	  insegs.push_back (Labeled_segment_2 (Segment_2 (Point_2 (q1,q2),
                                                    Point_2 (q3,q4)), i));
	}
	Diagram_1              min_diag;
  	upper_envelope_x_monotone_2 (insegs.begin(), insegs.end(),  min_diag);
  	Diagram_1::Edge_const_handle     ce = min_diag.leftmost();
	Diagram_1::Vertex_const_handle   cev;
	Diagram_1::Curve_const_iterator  cit;
	uint cedge=0;
	double px=0.0, py=0.0, cx=0.0, cy=0.0;
	//bool first=true;
	bool cempty=true;
	px=0.0;
	py=1.0;
  	while (ce != min_diag.rightmost())
	{
	    //std::cout << "Edge:";
	    if (! ce->is_empty())
	    {
	      	//for (cit = e->curves_begin(); cit != e->curves_end(); ++cit)
		cit=ce->curves_begin();
        	cedge= cit->data();
		cempty=false;
//		cout<<"Edge: "<<cedge<<endl;
    	    }
	    else
	    {
	 //       std::cout << " [empty]"<<endl;
		cempty=true;
	    }

	    cev = ce->right();
	    cx=CGAL::to_double(cev->point().x()); 
	    cy=CGAL::to_double(cev->point().y()); 

	//	cout<<cx<<" "<<cy<<endl;
	    if (!Tools::double_eq(px,cx,6))
	    {
			if (!cempty)
				cy=input[cedge].calculateY(cx);
			else
				//py=bottom.calculateY(px);
				cy=1.0;
			if (!cempty)
				py=input[cedge].calculateY(px);
			else
				py=1.0;
			
			segment sline;
			p1.x=px;
			p1.y=py;
			p2.x=cx;
			p2.y=cy;
			if (!cempty)
				sline.buildseg(p1, p2, input[cedge].objid,input[cedge].segid);
			else
				sline.buildseg(p1, p2, Tools::MAX,0);
			output.push_back(sline);
	    }

		px=cx;
		py=cy;

	    ce = cev->right();
	}	
	  CGAL_assertion (ce->is_empty());
	if (Tools::double_le(Tools::xMAX, cx, 6))
	{
		segment sline;
		p1.x=px;
		p1.y=1;
		p2.x=Tools::xMAX;
		p2.y=1;
		sline.buildseg(p1, p2, Tools::MAX, 0);
		output.push_back(sline);
	}
	  //std::cout << "Edge: [empty]" << std::endl;
}

void Envelope::printenvlp(vector<segment>& env)
{
	uint es=env.size();
	for (uint i=0;i<es;i++)
		cout<<env[i]<<endl;
}

