#include "rhdtree.h"

  RHDTree::RHDTree(vector<segment> smpl, Random* _rng, int _level)
  {
      vv.push_back(smpl);
      root=new rhdtnode();
      /*root->s.start.x=0;
      root->s.start.y=1;
      root->s.end.x=Tools::xMAX;
      root->s.end.y=1;
      root->s.objid=Tools::MAX;
      root->s.segid=0;*/
      root->sibling=NULL;
      //root->pconfl=NULL;
      height=0;
      _sampling();
      rng=_rng;
      level=_level;
      lenvfirst=NULL;
	count=0;
	qnode=0;
	envsize=0;
  } 

  RHDTree::~RHDTree()
 { 
	if (root!=NULL)
		delete root;
	if (lenvfirst!=NULL)
		delete lenvfirst;
	firstlst.clear();	
	vv.clear();
 } 
  void RHDTree::_sampling()
  {
    
    vector <segment>::iterator it; 
     while(vv.back().size()>4)
      {
	vector <segment> tmp;
	for(it=vv.back().begin();it!=vv.back().end();++it)
	  {
	    if(rng->uniform(0.0,1.0)>0.5)
		tmp.push_back((*it));
		//		o<<(*it)<<endl;
	  }
	vv.push_back(tmp);
      }
  }

  void RHDTree::buildtree(char* path)
  {
    firstlst.push_back(root);
    while(vv.size())
      {
	//char sfile[100]="";
	//sprintf(sfile, "%ssamples%d",path,height);
	//SDB::printSegments(vv.back(),sfile);
	buildlvl(vv.back(), path);	
	height++;
	vv.back().clear();
	vv.pop_back();
      }
    //traverse leaf level again to setup right conflict list
    setupLeafLevel(firstlst[this->height]);
  }
  

  void RHDTree::buildlvl(vector <segment> & D, char* path)
  {
    Envelope envlope;
    list <segment> res;
    rhdtnode * p=firstlst[height];
    rhdtnode * c=NULL;
    rhdtnode * tmp=NULL;
    int rel;
	//char sfile[100]="";
	//sprintf(sfile, "%sorig_envelope%d",path,height);

    envlope.getenvlp(D, res);
    //SDB::printSegments(res,sfile);
    while(p!=NULL)
      {
	if(res.empty())
	  {
	    return;//will it come to here?
	  }
	segment us=p->s;
	segment ls=res.front();
	res.pop_front();
	//	cout<<"us:"<<us<<endl;
	//cout<<"ls:"<<ls<<endl;
	while(Tools::double_eq(ls.start.x,ls.end.x,6))
	  {
	    ls=res.front();
	    res.pop_front();
	  }
	rel=relation(us,ls);
	switch(rel)
	  {
	  case 0:
	    if(c==NULL)
	      {
		c=new rhdtnode();
		firstlst.push_back(c);
		tmp=c;
	      }
	    else{
	      tmp=new rhdtnode();
	      c->sibling=tmp;
	    }
	    tmp->s=ls;
	    //tmp->pconfl=NULL;
	    p->child.push_back(tmp);
	    c=tmp;
	    if(Tools::double_eq(us.end.x,ls.end.x,6))
	      {
		rhdtnode * perr=p;
		p=p->sibling;
		if(p)
		  {
		    if(res.empty())
		      {
			cerr<<"Somthing wrong 1"<<endl;
			exit(1);
		      }
		  }//if
		else
		  {
		    if(!res.empty())
		      {
			while(!res.empty())
			  {
			    if(res.front().start.x==Tools::xMAX)
			      res.pop_front();
			    else
			      {
				if(ls.end.x==Tools::xMAX)
				  break;
				cerr<<"Somthing wrong 2 res.size:"<<res.size()<<" "<<res.back()<<endl;
				cerr<<"Somthing wrong 2 stat p:"<<perr->s<<endl;
				exit(1);
			      }
			  }
			tmp->sibling=NULL;
			return;
		      }
		    else{
		      tmp->sibling=NULL;
		      return;
		    }
		  }//else
	      }//if
	    break;//contain
	  case 1://chop
	    segment seg=ls;
	    double x,y;
	    if(Tools::double_eq(ls.start.x,us.end.x,6))
	      {
		p=p->sibling;
		res.push_front(ls);
		if(p==NULL)
		  {
		    cerr<<"Somthing wrong 5"<<endl;
		    exit(1);
		  }//if
		break;
	      }
	    else
	      if((Tools::lineSegmentIntersection(ls.start.x,ls.start.y,
				    ls.end.x,ls.end.y,
				    us.end.x,0.5,
				    us.end.x,2*Tools::MAX,
				       &x,&y))==false)
	      {
		if(Tools::double_eq(ls.start.x,us.start.x,6)||
		   Tools::double_eq(ls.end.x,us.end.x,6))
		  {
		    x=ls.start.x;
		    y=ls.start.y;
		  }
		else
		if(!(ls.objid==us.objid&&ls.segid==us.segid))
		  {
		    cerr<<ls<<endl;
		    cerr<<us<<endl;
		    exit(1);
		  }
	      }
	    if(!Tools::double_eq(x,ls.start.x,6))
	      {
		seg.start.x=x;
		seg.start.y=y;
		res.push_front(seg);
		ls.end.x=x;
		ls.end.y=y;
	      }
	    //  cout<<"Minus: "<<seg<<endl;

	    if(c==NULL)
	      {
		c=new rhdtnode();
		firstlst.push_back(c);
		tmp=c;
	      }
	    else
	      {
		tmp=new rhdtnode();
		c->sibling=tmp;
	      }//else
	    tmp->s=ls;
	    //tmp->pconfl=NULL;
	    p->child.push_back(tmp);
	    c=tmp;
	    p=p->sibling;
	    if(p==NULL)
	      {
		cerr<<"Somthing wrong 3"<<endl;
		exit(1);
	      }//if
	    break;//ls.end.x>us.end.x
	  }
      }
  }

  void RHDTree::insert2confl(segment &s, uint index)
  {
    bool judge=false;
    int j=0;
    int childsize=0;
    q.push(root);
    lEnv* tmpptr=NULL;
    bool inserted=false;
    while(!q.empty())
      {
	t=q.front();
	q.pop();
	qnode++;
	judge=segment::is_in_traz(t->s,s);
	if(judge)
	  {
	    if(t->lenv==NULL)//not leaf
	      {
		childsize=t->child.size();
		j=0;
		while(j!=childsize)
		  {
		    //    ++branch;
		    q.push((t->child)[j++]);
		  }//for
	      }//if
	    else//leaf,push in conflict
	      {
		if(tmpptr!=t->lenv)
		  {
		    inserted=t->lenv->insert(s, index);
		    tmpptr=t->lenv;
		    if (inserted==true)
			    ++count;
		  }
	      }
	  }//if
      }//while
  }

  void RHDTree::buildContainList(vector<RHDTree*>& trees)
  {
	int i; 
	if (this->level==0)
	 	return;
	lEnv* envPtr=NULL;
	lEnv* curEnvPtr=this->lenvfirst;
	while(curEnvPtr !=NULL)
	{	
		for (i=this->level-1; i>=0; i--)
		{
			envPtr=trees[i]->lenvfirst;
			while(envPtr!=NULL)	
			{
				if ( segment::AcontainB(curEnvPtr->s, envPtr->s)==true)
				{
					bool insert=true;
					for (uint j=0;j<curEnvPtr->contained.size();j++)
					{

						if (segment::AoverlapsB(curEnvPtr->contained[j]->s, envPtr->s))	
						{
							insert=false;						
							break;
						}
					}
					if (insert==true)
					{
						curEnvPtr->pushContainedEnv(envPtr);
					}
				}
				envPtr=envPtr->sibling;
			}
		}
		curEnvPtr=curEnvPtr->sibling;
	}
  }

  void RHDTree::setupLeafLevel(rhdtnode * first)
  {
    rhdtnode * p=first;
	int index=0;
    int objid,segid;
    if(first==NULL)
      {
	cerr<<"Something wrong 4"<<endl;
	exit(1);
      }
    objid=p->s.objid;
    segid=p->s.segid;
    //vector<uint> * ptr=new vector<uint>;
     lEnv* ptr= new lEnv(level);
    p->lenv = ptr;
    p->lenv->index=index;
    p->lenv->s=p->s;

    lenvfirst=ptr;
    rhdtnode* follow=p;

    p=p->sibling;
    while(p!=NULL)
      {
	if(p->s.objid==objid&&p->s.segid==segid)
	  {
	    p->lenv=ptr;
	  }
	else
	  {
	    index++;
	    ptr=new lEnv(level);
	    p->lenv=ptr;
	    p->lenv->index=index;
	    p->lenv->s=p->s;
	    follow->lenv->sibling=p->lenv;

	    objid=p->s.objid;
	    segid=p->s.segid;
	
	    follow->lenv->s.end=follow->s.end;
	  }
	follow=p;
	p=p->sibling;
      }
	envsize=index+1;
  }

  int RHDTree::relation(segment us,segment ls)
  {
	int res=0;
    if( ( Tools::double_le(ls.start.x,us.start.x,6) || Tools::double_eq(ls.start.x,us.start.x,6) ) &&
       ( Tools::double_le(us.end.x,ls.end.x,6) || Tools::double_eq(us.end.x,ls.end.x,6) ) )
      res=0;//fully contain
    if( Tools::double_le(ls.end.x,us.end.x,6) && !Tools::double_eq(ls.end.x,us.end.x,6))
      res=1;
	return res;
  }

 void RHDTree::writeConflictEnvelop(vector<segment>& segs, char* inputfile)
 {
	lEnv* ptr=this->lenvfirst;
	char buf[100]="";
        sprintf(buf,"mkdir -p %sIndex/S%d",inputfile, this->level);
	system(buf);
	sprintf(buf,"mkdir -p %sIndex/S%d/C",inputfile, this->level);
	system(buf);

	fstream envos;
        sprintf(buf,"%sIndex/S%d/env",inputfile,this->level);
  	envos.precision(12);
	envos.open(buf,ios::out);
	envos<<envsize<<endl;
	while(ptr!=NULL)
	{
	  sprintf(buf,"%sIndex/S%d/C/C%d",inputfile, this->level,ptr->index);
	  SDB::outputConflictList(segs, ptr->pconfl, buf);
	  envos<<ptr->s<<" "<<ptr->cfltsize<<" "<<ptr->distinctObj<<" "<<(ptr->totalMarked+1);
	  envos<<" "<<ptr->level<<" "<<ptr->index;
	  for (uint i=0;i<ptr->contained.size();i++)
	  {
		if (ptr->marked[i]==true)
		{
			envos<<" "<<ptr->contained[i]->level<<" "<<ptr->contained[i]->index;
		}
	  }	
	  envos<<endl;
	  ptr=ptr->sibling;
	}
	envos.close();			
 }
