#ifndef _SDB
#define _SDB
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <list>
#include <algorithm>
#include <time.h>
#include "Random.h"
#include "segment.h"
#include "point.h"
#include <string>
//#include "envelop.h"
#include "tools.h"

using namespace::std;

class SDB
{
	public:
		uint N;
		uint M;
		char* datafile;	
		vector<segment> segs;
		ifstream fin; 
		double ymax, ymin, xmin, xmax;
		Random rng;

	SDB(char* datafile);
	~SDB();
	
	void readData();	
	void readEasyData();	
	void sortSegments();
	void sample(double rate, vector<segment>& sampledSegs, vector<uint>& unsampledIndex);
	void printSegments();
	static void printSegments(vector<segment>& segs);
	static void printSegments(list<segment>& segs);
	static void printSegments(vector<segment>& segs, vector<uint> segIndex);
	static void printSegments(vector<segment>& segs, char* file);
	static void printSegments(list<segment>& segs, char* file);
	static void printSegments(vector<segment>& segs, vector<uint> segIndex, char* file);
	static uint outputConflictList(vector<segment>& segs, vector<uint>& segIndex, char* ofile);
	static uint readConflictList(vector<segment>& segs, char* ofile, uint ppos, uint csize);
	
	//	static void readNConflictList(vector<segment>& segs, vector<uint>& clevel, vector<uint>& cindex, char* filenames, uint& cios, uint B);
  	
	static void readEnvelop(const char* envfile, vector <segment> & s,vector <unsigned long int> & cn, vector<uint>& cd, vector<uint>& ppos);
	static void readREnvelop(const char* envfile, vector <segment> & s,vector <uint> & cn, vector <uint> & cd, vector<uint>& depend, vector <uint> &clevel, vector<uint>& cindex);
	static void printEnvelop(const char* envfile, vector <segment> & s,vector <unsigned long int> & cn);
	//list<segment> buildEnvelop(vector<segment>& input);	
};
#endif
