#include "segment.h"
segment::segment()
    {
      start.x=0;
      start.y=1;
      end.x=Tools::xMAX;
      end.y=1;
      A=0.0;
      B=1.0;
      objid=Tools::MAX;
      segid=0;
    }

double segment::calculateY(double x)
{
	double y=0.0;	
	y=A*x+B;
	return y;
}

void segment::buildseg()
  {
    A=(start.y-end.y)/(start.x-end.x);
    B=end.y-A*end.x;
  }

void segment::buildseg(shortsegment& st)
  {
    start=st.start;
    end=st.end;
    objid=(int)floor(st.sid/Tools::SEGIDLEN);
    segid=st.sid-objid*Tools::SEGIDLEN;
    A=(start.y-end.y)/(start.x-end.x);
    B=end.y-A*end.x;
  }

  void segment::buildseg(point p1, point p2, int oid, int pid)
  {
    objid=oid;
    segid=pid;
    if(p1<p2)
      {
	start=p1;
	end=p2;
      }
    else
      {
	start=p2;
	end=p1;
      }
    A=(start.y-end.y)/(start.x-end.x);
    B=end.y-A*end.x;
  }


  void segment::buildseg(pair <double,double> p1, pair <double,double> p2, int oid, int pid)
  {
    objid=oid;
    segid=pid;
    if(p1.first<p2.first)
      {
	start=p1;
	end=p2;
      }
    else
      {
	start=p2;
	end=p1;
      }
    A=(start.y-end.y)/(start.x-end.x);
    B=end.y-A*end.x;
  }
  
  bool segment::operator < (const segment & b) const
  {
    return (!Tools::double_le(start.x, b.start.x, 6));  
  }
  
  bool segment::operator ==(const segment & b) const
  {
    if(objid==b.objid&&segid==b.segid)
      return true;
    else
      return false;
  }

  segment & segment::operator=(const segment &b) 
    {
      objid=b.objid;
      segid=b.segid;
      start=b.start;
      end=b.end;
      A=b.A;
      B=b.B;
      return *this;
    }

  void segment::swap(segment &b)
  {
    segment tmp=b;
    b=*this;
    *this=tmp;
  }
  
 bool segment::is_in_traz(segment &ref, segment &q)
  {
    double x,y;
    if(Tools::double_le(ref.start.x, q.end.x,6)||
       Tools::double_le(q.start.x, ref.end.x,6))
      return false;
    if(Tools::double_eq_highp(ref.A, q.A, 0.0001))
      {
	if(Tools::double_le_highp(ref.B, q.B, 0.0001))
	  return false;
	else
	  return true;
      }//
    x=(ref.B-q.B)/(q.A-ref.A);
	y=q.A*x+q.B; 
    //if(double_le(x,ref.start.x,6)&&!double_eq(x,ref.start.x,6)&&double_le(ref.end.x,x,6)&&!double_eq(ref.end.x,x,6))
    //  return 1;
    if(Tools::double_le(ref.start.x,x,6))
      {
	if(Tools::double_le(q.A,ref.A,6))
	  return true;
	else
	  return false;
      }
    else if(Tools::double_le(x,ref.end.x,6))
      {
	if(Tools::double_le(ref.A,q.A,6))
	  return true;
	else
	  return false;
      }
    else if(Tools::double_le(q.end.y, y, 6) || Tools::double_le(q.start.y, y, 6))
	return true; 
    else  
	return false;
 } 
 
bool segment::AcontainB(segment sA, segment sB)
{
	bool contained=false;
	if (Tools::double_le_highp(sA.start.x, sB.start.x, 0.0001) && 
		Tools::double_le_highp(sA.end.x, sB.end.x, 0.0001))
	{
	
		double lx=0.0, ly=0.0, rx=0.0, ry=0.0;
		Tools::lineSegmentIntersection(
			sA.start.x, sA.start.y,
			sA.end.x, sA.end.y,
			sB.start.x, 2*Tools::MAX,
			sB.start.x, 0.5,
			&lx, &ly
		);
		if (Tools::double_le(sB.start.y, ly, 6))
		{
			Tools::lineSegmentIntersection(
				sA.start.x, sA.start.y,
				sA.end.x, sA.end.y,
				sB.end.x, 2*Tools::MAX,
				sB.end.x, 0.5,
				&rx, &ry
			);
			if (Tools::double_le(sB.end.y, ly, 6))
				contained=true;	
		}
	}
	return contained;
}

bool segment::AoverlapsB(segment sA, segment sB)
{
	bool overlaps=true;
	if (Tools::double_le_highp(sA.start.x, sB.end.x, 0.01) || 
		Tools::double_le_highp(sB.start.x, sA.end.x, 0.01))
		overlaps=false;
	return overlaps;
}

ostream& operator << (ostream& os, const segment& s)
{
  return os<<s.objid<<'\t'<<s.segid<<'\t'<<s.start<<'\t'<<s.end;
}

istream& operator >> (istream& is, segment& s)
{
  return   is>>s.objid>>s.segid>>s.start>>s.end;
}


