//! \file examples/Example_2/ex_envelope_segments.cpp
// Constructing the lower envelope of a set of segments.

#include "sdb.h"
#include "cgalenvelop.h"



int main (int argc, char* argv[])
{
  if(argc!=4)
    {
      cout<<"Usage: cglenv data_file rawdata(0:false 1:yes) samlpe_base"<<endl;
      return 0;
    }
	vector<segment> sampled;
	vector<uint> usampled;
	ifstream fin;
	int raw=atoi(argv[2]);
	int base=atoi(argv[3]);
  	std::list<Labeled_segment_2>   segments;

	if (raw==1)
	{	SDB sdb(argv[1]);
		sdb.readData();
		double srate=1.0/(double)base;
		sdb.sample(srate,sampled, usampled); 
	}
	else
	{
		fin.open(argv[1]);
		uint N=0;
		fin>>N;
		sampled.resize(N);
		for (uint i=0;i<N;i++)
		{
			fin>>sampled[i];
			sampled[i].buildseg();
		}
	}
	if (raw==1)
	{
		cerr<<sampled.size()<<endl;
		for (uint i=0;i<sampled.size();i++)
			cerr<<sampled[i]<<endl;
	}		
	
	Envelope env;
	vector<segment> envout;
	env.getenvlp(sampled,envout);
	env.printenvlp(envout);
  return (0);
}
