#include "tools.h" 

bool Tools::double_eq(double a, double b, int precision)
/*Handle double precision problem, a,b are positive*/
{
   double c=abs(a-b);
  bool eq=false;
  if (c<=0.0001)
    eq=true;
  return eq;
  
  /**********************/
  
  /**********************/
  /*a=round6(a);
  b=round6(b);
  int a_int=a,b_int=b;
  int i;
  a=a-a_int;
  b=b-b_int;

  if(a_int!=b_int)
    return NO;
  for(i=1;i<=precision;i++)
    {
      a_int=pow(10.0,i)*a;
      b_int=pow(10.0,i)*b;
      if(a_int!=b_int)
	return NO;
    }
  return YES;
  */
}
bool Tools::double_eq_highp(double a, double b, double precision)
/*Handle double precision problem, a,b are positive*/
{
   double c=abs(a-b);
  bool eq=false;
  if (c<=precision)
    eq=true;
  return eq;
}

bool Tools::double_le_highp(double a, double b, double precision)
/*Handle double precision problem, return a>=b*/
{
  	double c=a-b;
	bool le=false;
	if (c>precision)
		le=true;
		return le;
}

bool Tools::double_le(double a, double b, int precision)
/*Handle double precision problem, return a>=b*/
{
  	double c=a-b;
	bool le=false;
	if (c>0.0001)
		le=true;
		return le;
		/*
	  a=round6(a);
  b=round6(b);

  if(double_eq(a,b,6))
    {
      return YES;
    }
  if(a>0&&b<0)
    return YES;
  if(a<0&&b>0)
    return NO;
  int a_int=a,b_int=b;
  int i;
  a=a-a_int;
  b=b-b_int;
  if(a_int>b_int)
    return YES;
  if(a_int<b_int)
    return NO;
  for(i=1;i<=precision;i++)
    {
      a_int=pow(10.0,i)*a;
      b_int=pow(10.0,i)*b;
      if(a_int>b_int)
	return YES;
      if(a_int<b_int)
	return NO;
    }
    return YES;*/ 
}
  bool Tools::lineSegmentIntersection(
			       double Ax, double Ay,
			       double Bx, double By,
			       double Cx, double Cy,
			       double Dx, double Dy,
			       double *X, double *Y) 
  {

    double  distAB, theCos, theSin, newX, ABpos ;
    
    //  Fail if either line segment is zero-length.
    //    if ( (double_eq(Ax,Bx,6) && double_eq(Ay,By,6)) ||  (double_eq(Cx,Dx,6) &&  double_eq(Cy,Dy,6))) return false;
    
    //  Fail if the segments share an end-point.
    //if ( (double_eq(Ax,Cx,6) &&  double_eq(Ay,Cy,6)) ||  (double_eq(Bx,Cx,6) &&  double_eq(By,Cy,6))
    // ||   (double_eq(Ax,Dx,6) &&  double_eq(Ay,Dy,6)) ||  (double_eq(Bx,Dx,6) &&  double_eq(By,Dy,6))) {
    //  return false; }
    
    //  (1) Translate the system so that point A is on the origin.
    Bx-=Ax; By-=Ay;
    Cx-=Ax; Cy-=Ay;
    Dx-=Ax; Dy-=Ay;
    
    //  Discover the length of segment A-B.
    distAB=sqrt(Bx*Bx+By*By);
    
    //  (2) Rotate the system so that point B is on the positive X axis.
    theCos=Bx/distAB;
    theSin=By/distAB;
    newX=Cx*theCos+Cy*theSin;
    Cy  =Cy*theCos-Cx*theSin; Cx=newX;
    newX=Dx*theCos+Dy*theSin;
    Dy  =Dy*theCos-Dx*theSin; Dx=newX;
    
    //  Fail if segment C-D doesn't cross line A-B.
    if ( (Cy<0. && Dy<0.) || (Cy>=0. && Dy>=0.)) return false;
    
    //  (3) Discover the position of the intersection point along line A-B.
    ABpos=Dx+(Cx-Dx)*Dy/(Dy-Cy);
    
    //  Fail if segment C-D crosses line A-B outside of segment A-B.
    if (ABpos<0. || ABpos>distAB) return false;
    
    //  (4) Apply the discovered position to line A-B in the original coordinate system.
    *X=Ax+ABpos*theCos;
    *Y=Ay+ABpos*theSin;
    
    //  Success.
    return true; 
  }  
