
#include "app_config.h"
#include <portability.h>
#include <versions.h>

/***************************/
#include <sstream>
#include <fstream>
#include <fcntl.h>
#include <unistd.h>
#include <vector>
#include <iostream>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/stat.h>
#include <dirent.h>
#include "mtimer.h"
//#include "tools.h"
//#include "segment.h"
//#include "sdb.h"
//#include "mtimer.h"
/**************************/
using namespace std;
VERSION(test_ami_btree_cpp, "$Id: test_ami_btree.cpp,v 1.16 2009/03/19 17:36:13 lifeifei Exp $");

#include <cpu_timer.h>
#include <ami_btree.h>
#include <ami_stream.h>

#define SIZE_OF_STRUCTURE 256

// Key type.
//typedef TPIE_OS_OFFSET bkey_t;
typedef int bkey_t;// le

// Element type for the btree.
struct el_t {
  long x0,y0,x1,y1;
  int objid;
  int key;
  

  el_t(long k0, long k1, long k2, long k3, int id, int key_) 
  {
    x0=k0;
    y0=k1;
    x1=k2;
    y1=k3;					
    objid=id;
    key=key_;
  }

  el_t() {}
};

struct key_from_el {
  bkey_t operator()(const el_t& v) const { return v.key; }
};
// Temporary distinction btw UN*X and WIN, since there are some
// problems with the MMAP collection implementation.
#ifdef _WIN32
typedef AMI_btree< bkey_t,el_t,less<bkey_t>,key_from_el,BTE_COLLECTION_UFS > u_btree_t;
#else
typedef AMI_btree< bkey_t,el_t,less<bkey_t>,key_from_el > u_btree_t;
#endif

typedef AMI_STREAM< el_t > stream_t;

// Template instantiations (to get meaningful output from gprof)
//template class AMI_btree_node<bkey_t,el_t,less<bkey_t>,key_from_el>;
//template class AMI_btree_leaf<bkey_t,el_t,less<bkey_t>,key_from_el>;
//template class AMI_btree< bkey_t,el_t,less<bkey_t>,key_from_el,BTE_COLLECTION_UFS >;
//template class AMI_STREAM< el_t >;

class compare_el
{
public:
  int compare(const el_t &s1, const el_t &s2)
  {
    if(s1.key<=s2.key)
      return 1;
    else
      return -1;
  }
};

int main(int argc, char ** argv)
{
  if(argc!=3)
    {
      cerr<<argv[0]<<" sourcefile treename"<<endl;
      exit(-1);
    }
  ifstream in(argv[1]);
  long segnum=0;
  MM_manager.set_memory_limit(4*1024*1024*1024);
  MM_manager.enforce_memory_limit();
  srand(1);


  el_t tmp;
  AMI_btree_params params;
  params.node_block_factor = 0;
  params.leaf_block_factor = 0;
  params.leaf_cache_size = 32;
  params.node_cache_size = 64;
  char qtype;
  u_btree_t * bt=new u_btree_t(argv[2]);
  if(!bt->is_valid())
    {
      cerr<<"fail"<<endl;
      exit(1);
    }

  MTimer t;
  AMI_STREAM<el_t> instr;
  //  stream_t * sorted= new stream_t;
  AMI_err ae;
  int k=0;
  t.go();
  do
    {
      in>>tmp.x0>>tmp.y0>>tmp.x1>>tmp.y1>>tmp.objid>>qtype;
      tmp.key=rand();
      if ((ae = instr.write_item(tmp)) != AMI_ERROR_NO_ERROR) {
	cout << "AMI_ERROR " << ae << " during instr.write_item()" << endl;
	exit(1);
      }
      /*if(bt->insert(tmp)!= AMI_ERROR_NO_ERROR) {
	cout << "AMI_ERROR " << ae << " during insert" << endl;
	exit(1);
	}*/
      if(tmp.y0==-1)
	break;
      tmp.y0=-1;
    }while(1);
  
  
  if ((ae = instr.seek(0))!= AMI_ERROR_NO_ERROR) {
    cout << "AMI_ERROR " << ae << " during instr.seek()" << endl;
    exit(1);
  }
 
  
  if(bt->load(&instr,0.5,0.5)!= AMI_ERROR_NO_ERROR) {
    cout << "AMI_ERROR " << ae << " during load" << endl;
    exit(1);
  }
  t.stop();
  t.update();
  
  cout<<t.elapsed<<endl;
  return 0;
}
